/*
  This program tests your implentations of Evaluate.java,
  and AST2infix.java. When your implentations are correct,
  the output from this program should look exactly like
  the contents of the file output.txt.

  You should consider creating your own test expressions to make
  sure your implementations are correct.
*/

public class Tests
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "( prog ( var a ( array 1.2 3.4 5 6 ) ) )",

         "( prog ( begin " +
                  "( var n 5 ) " +
                  "( var a ( array dim n ) ) " +
                  "( print ( sizeOf a ) ) " +
                  "( var i 0 ) " +
                  "( while ( < i ( sizeOf a ) ) " +
                        "( begin " +
                           "( print ( index a i ) ) " +
                           "( set ( index a i ) ( - i ) ) " +
                           "( print ( index a i ) ) " +
                           "( set i ( + i 1 ) ) ) ) ) )",


        "( prog " +
          "( define g ( lambda x ( + 10 x ) ) ) " +
          "( define printA ( lambda a " +
            "( begin " +
              "( var i 0 ) " +
              "( while ( < i ( sizeOf a ) ) " +
                    "( begin " +
                       "( print ( index a i ) ) " +
                       "( set i ( + i 1 ) ) ) ) ) ) ) " +
          "( begin " +
            "( var a ( array 2 3 4 5 ) ) " +
            "( apply printA ( apply  g  a ) ) " +
            "( apply printA ( ^ 2 ( array 2 3 4 5 ) ) ) ) )",


        "( prog " +
          "( define fill ( lambda a " +
            "( begin " +
              "( var i 0 ) " +
              "( while ( < i ( sizeOf a ) ) " +
                    "( begin " +
                       "( set ( index a i ) ( rand 100 ) ) " +
                       "( set i ( + i 1 ) ) ) ) ) ) ) " +
          "( define max ( lambda a " +
            "( begin " +
              "( var m ( index a 0 ) ) " +
              "( var i 1 ) " +
              "( while ( < i ( sizeOf a ) ) " +
                    "( begin " +
                       "( if ( < m ( index a i ) ) " +
                           "( set m ( index a i ) ) " +
                           "0 ) " +
                       "( set i ( + i 1 ) ) ) ) " +
              "m ) ) ) " +   // this is the return value for max()
          "( define SIZE 20 ) " +
          "( begin " +
            "( var a ( array dim SIZE ) ) " +
            "( apply fill  a ) " +
            "( print a ) " +
            "( print ( apply max a ) ) ) )"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         try
         {
            Tree ast = BuildTree.buildTree( exprs[i] );

            System.out.println( PrettyPrinter.prettyPrint( ast ) + "\n" );
            System.out.println( AST2infix.ast2infix( ast ) + "\n" );

            Value value = Evaluate.evaluate( ast );
            System.out.println( "result = " + value );
         }
         catch (ParseException e)
         {
            System.out.println(e);
         }
         catch (EvalException e)
         {
            e.printStackTrace();
            //System.out.println(e);
         }
         System.out.println("=============================================");
      }
   }//main

}//Tests
